# PowerShell < 4
function Get-FileHash($filename) {
	$HashAlgorithm = New-Object -TypeName System.Security.Cryptography.SHA256CryptoServiceProvider
	$Path = Resolve-Path $filename
	@{Hash = [System.BitConverter]::ToString($HashAlgorithm.ComputeHash([System.IO.File]::ReadAllBytes($Path))) -replace '-'}
}

$URL = "https://trac.wildfiregames.com/export/HEAD/ps/trunk/binaries/system"
# Invoke-WebRequest "$URL/SHA256SUMS" -OutFile SHA256SUMS

Get-Content SHA256SUMS | ForEach-Object {
	$hash,$filename = $_ -split ' +\*?'

	if((Test-Path -Path $filename) -And (Get-FileHash $filename).Hash.toLower() -eq $hash) {
		Write-Host "$filename`: OK"
    } else {
		Write-Host "$filename`: FAILED" -ForegroundColor Red
		# Invoke-WebRequest "$URL/$filename" -OutFile $filename
		Write-Host "$filename`: Hash $((Get-FileHash $filename).Hash.toLower())" -ForegroundColor Green
	}
}